<?php
/*
Animation code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wacintaki Poteto modifications Copyright 2004-2008 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.3.14 - Last modified 6/20/2008
*/


/*
NOTES:

ChibiPaint sends data as multipart encoded (yay!), so this code is quite different from the other oekaki applets.

Layers file is not yet supported.  ChibiPaint does not yet support animation data, but I would prefer not to use the animation flag as a substitute for layers, just in case animation support is added in the future.
*/


// Error reporting
function print_ok() {
	global $dbconn;
	if (!empty ($dbconn)) {
		mysql_close ($dbconn);
	}

	header('Content-Type: text/plain');
	exit ("CHIBIOK\n");
}
function quiet_exit($exit_err) {
	global $dbconn;
	if (!empty ($dbconn)) {
		mysql_close ($dbconn);
	}

	header ('Content-Type: text/plain');
	exit ("CHIBIERROR {$exit_err}\n");
}


// Load bootstrap, quiet mode
// Get OekakiU any way we can!  boot.php will clean this.
$OekakiU    = '';
$OekakiPass = '';
if (isset ($_REQUEST['usr']) && isset ($_REQUEST['vcode'])) {
	// Preferred
	$OekakiU    = addslashes($_REQUEST['usr']);
	$OekakiPass = addslashes($_REQUEST['vcode']);
} elseif (isset ($_REQUEST['OekakiU']) && isset ($_REQUEST['OekakiPass'])) {
	// Backup
	$OekakiU    = $_REQUEST['OekakiU'];
	$OekakiPass = $_REQUEST['OekakiPass'];
}
if (empty ($OekakiU)) {
	// English only
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
$quiet_mode  = TRUE;
$no_template = TRUE;
$no_online   = TRUE;
define ('BOOT', 1);
require ('boot.php');
require ('paintsave.php');


// Clean input
//$mode    = {boot.php};
$edittimes = w_gpc('edittimes', 'i');
$edit      = w_gpc('edit', 'i+');
$import    = w_gpc('import', 'i+');
$user_pass = w_gpc('pw'); // Encoded with make_edit_pass()



// ChibiPaint data
$buffer        = NULL;
$buffer_anim   = NULL;
$buffer_layers = NULL;
{
	// Image
	if (!isset($_FILES['picture'])) {
		quiet_exit('No picture data was received. Try again.');
	}
	if ($_FILES['picture']['error'] > 0 || empty ($_FILES['picture']['tmp_name'])) {
		if ($_FILES['picture']['error'] == UPLOAD_ERR_NO_FILE) {
			quiet_exit('No picture data was received. Try again.');
		}
		quiet_exit('An error occured while uploading. Try again.');
	}
	if ($_FILES['picture']['size'] > $cfg['max_pic']) {
		quiet_exit('Picture too large!  Max size is '.$cfg['max_pic'].' bytes.');
	}
	$buffer = file_get_contents ($_FILES['picture']['tmp_name']);


	// Animation
	//if ($_FILES['animation']['tmp_name']) {
	//	if ($_FILES['animation']['error'] == 0) {
	//		if ($_FILES['animation']['size'] <= $cfg['max_anim'])) {
	//			$buffer_anim = file_get_contents ($_FILES['animation']['tmp_name']);
	//		}
	//	}
	//}


	// Layers.  Use move_uploaded_file() later in this script?
	//if ($_FILES['chibifile']['tmp_name']) {
	//	if ($_FILES['chibifile']['error'] == 0) {
	//		if ($_FILES['chibifile']['size'] <= $cfg['max_pic'])) {
	//			$buffer_anim = file_get_contents ($_FILES['chibifile']['tmp_name']);
	//		}
	//	}
	//}
}


// Insert new slot into database
if ($mode == 'norm' || $mode == 'anim') {
	$resno = get_new_picnumber();
	if ($resno == 0) {
		w_log(WLOG_FAIL, 'chibipaintget: cannot allocate new PIC_ID');
		quiet_exit($langop_err_picts);
	}

	// Cleanup slots
	$result = clean_picture_slots();

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', comment='', PIC_ID='$resno', IP='$address', datatype=4, edittime='$thetime', password=''";
		if ($mode == 'anim') {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = mysql_query ($sqlres);

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		w_log_sql('chibipaintget: cannot save image '.$resno);
		quiet_exit($langop_err_saveimg);
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	// Verify edit, otherwise invalidate it
	$resno = verify_edit($edit, $user_pass);

	$edittime2 = time() - $edittimes;
	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
}


// Write files
//
// Save image/anim data.  Filetype is automatic!
if (!save_image($buffer, $resno)) {
	w_log(WLOG_FAIL, 'chibipaintget: cannot save image '.$resno);
	quiet_exit($langop_err_saveimg);
}
//if (!empty ($buffer_anim)) {
//	save_anim($buffer_anim, $resno, '???');
//}
//if (!empty ($buffer_layers)) {
//	save_anim($buffer_layers, $resno, 'chi');
//}


// Credit original artist, if required
if ($import) {
	$result = mysql_query ("SELECT usrname, origart FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='{$import}'");

	if ($result && mysql_num_rows ($result) > 0) {
		$import_check = mysql_fetch_array ($result);
		$import_check['usrname'] = addslashes ($import_check['usrname']);
		$import_check['origart'] = addslashes ($import_check['origart']);

		if ($import_check['usrname'] != $OekakiU) {
			// Not artist!  We'll need to update 'origart'.

			if ($import_check['origart'] != $OekakiU) {
				// Not original artist, either.  Update.
				$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET origart='{$import_check['usrname']}' WHERE PIC_ID='{$resno}'");
			} else {
				// Retouched by original artist.  Clear 'origart' if set
				$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET origart='' WHERE PIC_ID='{$resno}'");
			}
		}
	}
}


print_ok();

?>